// C Source File
// Created 2001-09-16; 20:47:33
/*
**************************[JesBank]***************************
** JesBank is a help tool for keep track of your bank       **
** accounts. JesBank is a part of the much larger 					**
** JES:Workstation 'project', where we want to make a       **
** package for work. Having a Spread sheet program, this		**
** JesBank program, an agenda, and a stockmarket program    **
** TI's machines will then be able to take the step out from**
** being a gaming/advanced calculator machine, to a full    **
** workable Workstation.																		**
**																													**
** Be sure to visit JESystems at http://jesystems.cjb.net   **
** Or mail us at jon80@home.se															**
**************************************************************
*/

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "extgraph.h"

short _ti89;                  // Produce .89Z File
short _ti92plus;              // Produce .9XZ File

void *vlight = NULL;
void *vdark = NULL;

struct cell_list {
	float value;
	int y;
	char info[20];
};
struct cell_list *cells;

char open_file[8];

int cell_num;
//               < MEMORY HANDLING > 
int need_new_cell(int y)
{
	int tmp=1;
	while (tmp<cell_num)
	{
		if (cells[tmp].y==y) return tmp;
		tmp++;
	}
	return 0;
}

void add_cell(float val,int y,char inf[20])
{
	int loc=0;
 	loc=need_new_cell(y);
	if (loc==0)
	{
		// increase the cell_num,
		cell_num++;
		// make more memory to the cells variable
 	 	cells=realloc(cells,cell_num*sizeof(*cells));
		// Enter the values of the new cell
		cells[cell_num-1].value = val;
		cells[cell_num-1].y = y;
		strcpy(cells[cell_num-1].info , inf);
		// Update the screen with new info..
	} else {
		// Enter the values of the new cell
		cells[loc].value = val;
		cells[loc].y = y;
		strcpy(cells[loc].info , inf);
	}
}

int Del_cell(int loc)
{
	int tmp=1;
	int got_one=0;

	while (tmp<cell_num)
	{
		if (cells[tmp].y==loc) {
			// Delete this cell then..
			cells[tmp].value = cells[cell_num-1].value;
			cells[tmp].y = cells[cell_num-1].y;
			strcpy(cells[tmp].info , cells[cell_num-1].info);
			// Allright.. let's kill it ;)
			cell_num--;
		  cells=realloc(cells,cell_num*sizeof(*cells));
			got_one=1;
		}
		if (cells[tmp].y>loc) {
			cells[tmp].y--;
		}
		tmp++;
	}
  // It's all gone!
  // Update the screen with the new info
  if (got_one) return TRUE; // We found a cell
  return FALSE;
}
// 							< / MEMORY HANDLING >

void Add_Row(int row)
{
	int temp=0;
	while (temp<cell_num)
	{
		if (cells[temp].y>=row) cells[temp].y++;
		temp++;
	}
}

// 							< DRAW FUNCTIONS, JUST FOR YOUR EYES >

void Draw_3dbutton(int x,int y,int width,int source)
{
	if (source==0)
	{
		// Border
		DrawGrayRect2B(x,y,x+width,y+9,COLOR_WHITE,RECT_FILLED,vlight,vdark);
		DrawGrayRect2B(x,y,x+width,y+9,COLOR_BLACK,0,vlight,vdark);
		// The cell itself
		DrawGrayRect2B(x+2,y+2,x+width-2,y+7,COLOR_LIGHTGRAY,RECT_FILLED,vlight,vdark);
		FastDrawGrayLine2B(x+2,y+8,x+width-1,y+8,COLOR_DARKGRAY,vlight,vdark);
		FastDrawGrayLine2B(x+width-1,y+2,x+width-1,y+8,COLOR_DARKGRAY,vlight,vdark);
		FastDrawGrayLine2B(x+width-2,y+1,x+width-1,y+1,COLOR_LIGHTGRAY,vlight,vdark);
		FastDrawGrayLine2B(x+1,y+8,x+1,y+8,COLOR_DARKGRAY,vlight,vdark);	
		return;
	}
	if (source==1)
	{
		// Border
		DrawGrayRect2B(x,y,x+width,y+9,COLOR_WHITE,RECT_FILLED,GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
		DrawGrayRect2B(x,y,x+width,y+9,COLOR_BLACK,0,GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
		// The cell itself
		DrawGrayRect2B(x+2,y+2,x+width-2,y+7,COLOR_LIGHTGRAY,RECT_FILLED,GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
		FastDrawGrayLine2B(x+2,y+8,x+width-1,y+8,COLOR_DARKGRAY,GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
		FastDrawGrayLine2B(x+width-1,y+2,x+width-1,y+8,COLOR_DARKGRAY,GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
		FastDrawGrayLine2B(x+width-2,y+1,x+width-1,y+1,COLOR_LIGHTGRAY,GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
		FastDrawGrayLine2B(x+1,y+8,x+1,y+8,COLOR_DARKGRAY,GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
		return;
	}
}

void Draw_cell(int y,int border)
{
	DrawGrayRect2B(2,y,156,y+9,COLOR_BLACK,0,vlight,vdark);
	DrawGrayRect2B(3,y+1,155,y+8,COLOR_WHITE,RECT_FILLED,vlight,vdark);
	
	Draw_3dbutton(2,y,15,0);
	
	FastDrawGrayLine2B(110,y,110,y+9,COLOR_BLACK,vlight,vdark);
	FastDrawGrayLine2B(17,y,17,y+9,COLOR_BLACK,vlight,vdark);
	
	// Border.. 3D border that is
	if (border)
	{
		FastDrawGrayLine2B(157,y+1,157,y+10,COLOR_DARKGRAY,vlight,vdark);
		FastDrawGrayLine2B(3,y+10,157,y+10,COLOR_DARKGRAY,vlight,vdark);		
	}
}

void Draw_menu_block(int x)
{
	FastDrawGrayLine2B(x,0,x,5,COLOR_BLACK,vlight,vdark);
	FastDrawGrayLine2B(x+20,0,x+20,5,COLOR_BLACK,vlight,vdark);
	FastDrawGrayLine2B(x+1,6,x+19,6,COLOR_BLACK,vlight,vdark);
	FastDrawGrayLine2B(x+1,0,x+1,4,COLOR_WHITE,vlight,vdark);
	FastDrawGrayLine2B(x+1,0,x+17,0,COLOR_WHITE,vlight,vdark);
	FastDrawGrayLine2B(x+3,5,x+19,5,COLOR_DARKGRAY,vlight,vdark);
	FastDrawGrayLine2B(x+19,1,x+19,5,COLOR_DARKGRAY,vlight,vdark);
}

void Draw_Board(int start_num)
{
	int x=0;
	char temp[20];
	temp[0]=0;

	// Draws the cells
	DrawGrayRect2B(0,0,LCD_WIDTH,LCD_HEIGHT,COLOR_LIGHTGRAY,RECT_FILLED,vlight,vdark);
	while (x<8)
	{
		Draw_cell(15+(x*9),TRUE);		
		x++;
	}

	FontSetSys(F_4x6);
	
	// Draws the 3D button for the value of the bank book
	Draw_3dbutton(110,87,46,0);
	FastDrawGrayLine2B(157,87,157,96,COLOR_DARKGRAY,vlight,vdark);
	// Draw the value
	sprintf(temp,"%f",cells[0].value);
	DrawGrayStr2B(112,89,temp,A_NORMAL,vlight,vdark);
	
	// Draw's the name of the current bank book
	Draw_3dbutton(82,6,60,0);
	DrawGrayStr2B(84,9,cells[0].info,A_NORMAL,vlight,vdark);
	
	// ::Draw the menu::
	Draw_menu_block(0);
	Draw_menu_block(20);
	Draw_menu_block(40);
	Draw_menu_block(60);
	DrawGrayStr2B(2,0,"New",A_NORMAL,vlight,vdark);
	DrawGrayStr2B(22,0,"Open",A_NORMAL,vlight,vdark);
	DrawGrayStr2B(42,0,"Save",A_NORMAL,vlight,vdark);
	DrawGrayStr2B(62,0,"Quit",A_NORMAL,vlight,vdark);
	
	// ::Draw the status bar::
	DrawGrayRect2B(0,LCD_HEIGHT-6,80,LCD_HEIGHT,COLOR_WHITE,RECT_FILLED,vlight,vdark);
	FastDrawGrayLine2B(0,LCD_HEIGHT-7,80,LCD_HEIGHT-7,COLOR_BLACK,vlight,vdark);
	FastDrawGrayLine2B(81,LCD_HEIGHT-6,81,LCD_HEIGHT,COLOR_BLACK,vlight,vdark);
	
	// Time to draw the numbers	
	x=0;
	while (x<8)
	{
		sprintf(temp,"%d",start_num+x+1);
		if ((start_num+x+1)<10)
			DrawGrayStr2B(7,17+(x*9),temp,A_NORMAL,vlight,vdark);
		else if ((start_num+x+1)<100)
			DrawGrayStr2B(5,17+(x*9),temp,A_NORMAL,vlight,vdark);
		else
			DrawGrayStr2B(3,17+(x*9),temp,A_NORMAL,vlight,vdark);
		x++;
	}
	
	// Ok.. draw the cells now.. if there's anything to draw that is..
	x=1;
	while (x<cell_num) {
		if ((cells[x].y-start_num>=0) && (cells[x].y-start_num<=7)) {
			// Draw this little thing ;)
			DrawGrayStr2B(19,17+((cells[x].y-start_num)*9),cells[x].info,A_NORMAL,vlight,vdark);
			sprintf(temp,"%f",cells[x].value);
			DrawGrayStr2B(112,17+((cells[x].y-start_num)*9),temp,A_NORMAL,vlight,vdark);
		}
		x++;
	}
}

int Run_Menu(void)
{
	int x=0,key=0,tmp=0;
	char buffer[8];
	char name[20];
	int i;
	FILE *f;
	name[0]=0;
	FastCopyScreen(GetPlane(LIGHT_PLANE),vlight);
	FastCopyScreen(GetPlane(DARK_PLANE),vdark);

	/*
	======================
	Test for saving files
	======================
	*/
	InvertGrayRect2B(x,0,x+20,6,GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
	while (key!=KEY_ENTER)
	{
		key=ngetchx();
		if ((key==KEY_RIGHT) && (x<60))
		{
			InvertGrayRect2B(x,0,x+20,6,GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
			x+=20;
			InvertGrayRect2B(x,0,x+20,6,GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
		}
		if ((key==KEY_LEFT) && (x>0))
		{
			InvertGrayRect2B(x,0,x+20,6,GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
			x-=20;
			InvertGrayRect2B(x,0,x+20,6,GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
		}
		if (key==KEY_ESC) return 0;
	}
	if (x==60) return 1;  // quit
	if (x==0) { // new one!
		cell_num=1;
		open_file[0]=0;
		// make more memory to the cells variable
 	 	cells=realloc(cells,cell_num*sizeof(*cells));
		// Enter the values of the new cell
		cells[cell_num-1].value = 0;
		cells[cell_num-1].y = 0;
		strcpy(cells[cell_num-1].info , "JesBank");
		// Draw the new board		
		return 2;
	}
	if (x==20) { // Load
		Draw_3dbutton((LCD_WIDTH/2)-23,(LCD_HEIGHT/2)-4,46,1);
//		110/87
		buffer[0] = 0;
		i=0;
		key=0;
		do
 		{
			for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy ((LCD_WIDTH/2)-21,(LCD_HEIGHT/2)-2,"%s|   ", buffer);}
		  key = ngetchx ();
// 		if ((isalpha(key) && i < 15) || (isdigit(key)&&i>0)) buffer[i++] = key;
			if(key!=KEY_BACKSPACE && key>31 && key<255 && i<8) buffer[i++] = key; //add support for everything
   		if (key == KEY_BACKSPACE && i) i--;
   			buffer[i] = 0;
    } while (key != KEY_ENTER);
		f = fopen (buffer, "rb");
		if (f!=NULL) 
		{
			strcpy(open_file , buffer);
			fread (&cell_num, sizeof(cell_num), 1, f);
 	 		cells=realloc(cells,cell_num*sizeof(*cells));
			fread(cells,sizeof(*cells),cell_num,f);
			fclose (f);
			return 3;
		} else {
	    for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy (0,LCD_HEIGHT-5,"File not found");}	
			return 0;
		}
		
	}
	if (x==40) { // Save
		cells[0].y = cell_num; // Store how many cells we got
		
		if (open_file[0]==0)
		{
			Draw_3dbutton((LCD_WIDTH/2)-40,(LCD_HEIGHT/2)-4,80,1);
//		110/87
			buffer[0] = 0;
			i=0;
			key=0;
			// Input filename
			do
 			{
				for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy ((LCD_WIDTH/2)-40,(LCD_HEIGHT/2)-2,"filename: %s|   ", buffer);}
			  key = ngetchx ();
//	 		if ((isalpha(key) && i < 15) || (isdigit(key)&&i>0)) buffer[i++] = key;
				if(key!=KEY_BACKSPACE && key>31 && key<255 && i<8) buffer[i++] = key; //add support for everything
   			if (key == KEY_BACKSPACE && i) i--;
   				buffer[i] = 0;
   	 } while (key != KEY_ENTER);
	
			// Input name of the bankbook
			i=0;
			key=0;
			Draw_3dbutton((LCD_WIDTH/2)-40,(LCD_HEIGHT/2)-4,80,1);
			do
 			{
				for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy ((LCD_WIDTH/2)-40,(LCD_HEIGHT/2)-2,"Bankbook: %s|   ", name);}
			  key = ngetchx ();
	// 		if ((isalpha(key) && i < 15) || (isdigit(key)&&i>0)) buffer[i++] = key;
				if(key!=KEY_BACKSPACE && key>31 && key<255 && i<20) name[i++] = key; //add support for everything
 	  		if (key == KEY_BACKSPACE && i) i--;
 	  			name[i] = 0;
 	  	} while (key != KEY_ENTER);
			strcpy(cells[0].info , name);
			f = fopen (buffer, "wb");
		} else {
			f = fopen (open_file, "wb");
		}
		fwrite(&cells[0].y,2,1,f);
		fwrite(cells,sizeof(*cells),cell_num,f);
		fputc(0,f);
		fputs("jb_",f);
		fputc(0,f);
		fputc(OTH_TAG,f);
		fclose (f);
		return 0;
	}
	FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
	FastCopyScreen(vdark,GetPlane(DARK_PLANE));
	return 1;
}

void Xor_Selection(int y,int selected_x)
{
	if (y==0) InvertGrayRect2B(3,16+(selected_x*9),16,23+(selected_x*9),vlight,vdark);
	if (y==1) InvertGrayRect2B(18,16+(selected_x*9),109,23+(selected_x*9),vlight,vdark);
	if (y==2) InvertGrayRect2B(111,16+(selected_x*9),155,23+(selected_x*9),vlight,vdark);
}

// 							< / DRAW FUNCTIONS, JUST FOR YOUR EYES >

void _main(void)
{
	int start_num=0;
	int key=0;
	int selected_x=0,y=0;
	int i=0,exit=0;
	int tmp=0;
	char buffer[20];
	float temp;

	cells=malloc(sizeof(*cells)); // 1 cell, automaticly
	cell_num=1; // need to have this on 1 cell, cause we automaticly uses 1 cell ;)
	
	if (!GrayOn()) return;
	vlight=malloc(LCD_SIZE);
	vdark=malloc(LCD_SIZE);
	ClearGrayScreen2B(vlight,vdark);
	// Go back to 0 with everything ;)
	strcpy(cells[0].info , "JesBank");
	cells[0].value = 0;
	cells[0].y = 0;
	open_file[0]=0;
	// Draw the board!	
	Draw_Board(start_num);
	// Draw selected cell
	InvertGrayRect2B(3,16+(selected_x*9),16,24+(selected_x*9),vlight,vdark);
	// Place it on board
	FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
	FastCopyScreen(vdark,GetPlane(DARK_PLANE));

	while (exit==0)
	{
    for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy (0,LCD_HEIGHT-5,"Size: %d", cell_num*(int)sizeof(*cells));}	
		key=ngetchx();
		if (key==KEY_DOWN)
		{
			Xor_Selection(y,selected_x);
			selected_x++;
			if ((selected_x>7) && (y<=1))
			{
				selected_x=7;
				start_num+=7;
				Draw_Board(start_num);
			}
			if (selected_x>=8)
			{
				selected_x=8;
			}	
			Xor_Selection(y,selected_x);
			FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
			FastCopyScreen(vdark,GetPlane(DARK_PLANE));
		}
		if (key==KEY_UP)
		{
			Xor_Selection(y,selected_x);
			selected_x--;
			if (selected_x<0)
			{
				selected_x=0;
				if (start_num>2) {
					start_num-=7;
					Draw_Board(start_num);
				}
			}
			Xor_Selection(y,selected_x);
			FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
			FastCopyScreen(vdark,GetPlane(DARK_PLANE));
		}
		if ((key==KEY_RIGHT) && (y<2)) {
			Xor_Selection(y,selected_x);
			y++;
			Xor_Selection(y,selected_x);
			FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
			FastCopyScreen(vdark,GetPlane(DARK_PLANE));
		}
		if ((key==KEY_LEFT) && (y>0) && (selected_x<8)) {
			Xor_Selection(y,selected_x);
			y--;
			Xor_Selection(y,selected_x);
			FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
			FastCopyScreen(vdark,GetPlane(DARK_PLANE));
		}
		if (key==KEY_CLEAR)
		{
			Del_cell(selected_x+start_num);
			Draw_Board(start_num);
			Xor_Selection(y,selected_x);
			FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
			FastCopyScreen(vdark,GetPlane(DARK_PLANE));
		}
		if (key==KEY_ESC)
		{
			// Time to run the menu ;).. this could be done very nice
			// After a few fixes :)
//			ClearGrayScreen2B(GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
//			FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
//			FastCopyScreen(vdark,GetPlane(LIGHT_PLANE));			
			// As you can C, we have now created a nice little Light gray background for our menu ;)
			exit = Run_Menu();
			if (exit==2) {
				start_num=0;
				Draw_Board(start_num);
				Xor_Selection(y,selected_x);
				exit=0;
			}
			if (exit==3)
			{
				Draw_Board(start_num);
				Xor_Selection(y,selected_x);
				exit=0;				
			}
			// Change back to normal ..
			FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
			FastCopyScreen(vdark,GetPlane(DARK_PLANE));
		}
		if (key==KEY_F1)
		{
			Add_Row(selected_x+start_num);
			Draw_Board(start_num);
			Xor_Selection(y,selected_x);
			FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
			FastCopyScreen(vdark,GetPlane(DARK_PLANE));
		}
		if (key==KEY_ENTER)
		{
			Xor_Selection(y,selected_x);
			FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
			FastCopyScreen(vdark,GetPlane(DARK_PLANE));
			if (y==0)
			{
			  buffer[0] = 0;
		  	i=0;
			  key=0;
			  do
	 	   	{
			    for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy (112,17+(selected_x*9),"%s|   ", buffer);}	

		      key = ngetchx ();
// 		    if ((isalpha(key) && i < 15) || (isdigit(key)&&i>0)) buffer[i++] = key;
					if(key!=KEY_BACKSPACE && key>31 && key<255 && i<20) buffer[i++] = key; //add support for everything
 	  		  if (key == KEY_BACKSPACE && i) i--;
 		     	buffer[i] = 0;
	 	   	} while (key != KEY_ENTER);
		    for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy (112,17+(selected_x*9),"%s   ", buffer);}
				temp=atof (buffer);

			  buffer[0] = 0;
			  i=0;
			  key=0;
			  do
 		   	{
			    for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy (19,17+(selected_x*9),"%s|   ", buffer);}

		      key = ngetchx ();
// 		    if ((isalpha(key) && i < 15) || (isdigit(key)&&i>0)) buffer[i++] = key;
					if(key!=KEY_BACKSPACE && key>31 && key<255 && i<20) buffer[i++] = key; //add support for everything
   			  if (key == KEY_BACKSPACE && i) i--;
   		   	buffer[i] = 0;
    		} while (key != KEY_ENTER);

				// This takes away that _ marker, and saves the stuff in vlight/vdark
		    for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy (19,17+(selected_x*9),"%s   ", buffer);}
  	  	// Add this cell.. so we save it..
				if (!is_nan(temp)) // Basicly, if it's not a 'not a number' (basicly if it's a number)
				{
					add_cell(temp ,selected_x+start_num,buffer);
					cells[0].value+=temp;					
				}
			}
			if (y==1)
			{
				exit=need_new_cell(selected_x+start_num);
				if (exit!=0)
				{
			  buffer[0] = 0;
			  i=0;
			  key=0;
			  do
 		   	{
			    for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy (19,17+(selected_x*9),"%s|   ", buffer);}
		      key = ngetchx ();
// 		    if ((isalpha(key) && i < 15) || (isdigit(key)&&i>0)) buffer[i++] = key;
					if(key!=KEY_BACKSPACE && key>31 && key<255 && i<20) buffer[i++] = key; //add support for everything
   			  if (key == KEY_BACKSPACE && i) i--;
   		   	buffer[i] = 0;
    		} while (key != KEY_ENTER);

				// This takes away that _ marker, and saves the stuff in vlight/vdark
		    for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy (19,17+(selected_x*9),"%s   ", buffer);}
    		strcpy(cells[exit].info , buffer);
				}				
				exit=0;
			}
			if ((y==2) && (selected_x==8)) // Time to update the saldo..
			{
			  buffer[0] = 0;
		  	i=0;
			  key=0;
			  do
	 	   	{
			    for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy (112,17+(selected_x*9),"%s|   ", buffer);}	

		      key = ngetchx ();
// 		    if ((isalpha(key) && i < 15) || (isdigit(key)&&i>0)) buffer[i++] = key;
					if(key!=KEY_BACKSPACE && key>31 && key<255 && i<20) buffer[i++] = key; //add support for everything
 	  		  if (key == KEY_BACKSPACE && i) i--;
 		     	buffer[i] = 0;
	 	   	} while (key != KEY_ENTER);
		    for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy (112,17+(selected_x*9),"%s   ", buffer);}
				temp=atof (buffer);
				if (!is_nan(temp)) // Basicly, if it's not a 'not a number' (basicly if it's a number)
					cells[0].value=temp; // Update the value stuff..
			}
			if ((y==2) && (selected_x!=8))
			{
				exit=need_new_cell(selected_x+start_num);
				if (exit!=0)
				{
			  buffer[0] = 0;
		  	i=0;
			  key=0;
				cells[0].value-=cells[exit].value; // Take back what cell[exit] did to the saldo
			  do
	 	   	{
			    for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy (112,17+(selected_x*9),"%s|   ", buffer);}	

		      key = ngetchx ();
// 		    if ((isalpha(key) && i < 15) || (isdigit(key)&&i>0)) buffer[i++] = key;
					if(key!=KEY_BACKSPACE && key>31 && key<255 && i<20) buffer[i++] = key; //add support for everything
 	  		  if (key == KEY_BACKSPACE && i) i--;
 		     	buffer[i] = 0;
	 	   	} while (key != KEY_ENTER);
		    for(tmp=0;tmp<2;tmp++) {SetPlane(tmp);printf_xy (112,17+(selected_x*9),"%s   ", buffer);}
				temp=atof (buffer);
				if (!is_nan(temp)) // Basicly, if it's not a 'not a number' (basicly if it's a number)
				{
					cells[exit].value=temp;	
					cells[0].value+=temp;					
				}
				exit=0;
				}
			}
			// Update the screen with the new value of the bank book
			DrawGrayRect2B(112,89,154,94,COLOR_LIGHTGRAY,RECT_FILLED,GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
	  	sprintf(buffer,"%f",cells[0].value);
			DrawGrayStr2B(112,89,buffer,A_NORMAL,GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
			FastCopyScreen(GetPlane(LIGHT_PLANE),vlight);
			FastCopyScreen(GetPlane(DARK_PLANE),vdark);
			Xor_Selection(y,selected_x);
			FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
			FastCopyScreen(vdark,GetPlane(DARK_PLANE));
	   	key=0;	
		}
	}
  
  GrayOff();
  
  free(cells);free(vlight);free(vdark);
}
